Loading...
1#!/bin/sh
2#
3# link vmlinux
4#
5# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
6# $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
7# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
8# Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
9#
10# vmlinux
11# ^
12# |
13# +-< $(KBUILD_VMLINUX_INIT)
14# | +--< init/version.o + more
15# |
16# +--< $(KBUILD_VMLINUX_MAIN)
17# | +--< drivers/built-in.o mm/built-in.o + more
18# |
19# +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31# Nice output in kbuild format
32# Will be supressed by "make -s"
33info()
34{
35 if [ "${quiet}" != "silent_" ]; then
36 printf " %-7s %s\n" ${1} ${2}
37 fi
38}
39
40# Thin archive build here makes a final archive with
41# symbol table and indexes from vmlinux objects, which can be
42# used as input to linker.
43#
44# Traditional incremental style of link does not require this step
45#
46# built-in.o output file
47#
48archive_builtin()
49{
50 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
51 info AR built-in.o
52 rm -f built-in.o;
53 ${AR} rcsT${KBUILD_ARFLAGS} built-in.o \
54 ${KBUILD_VMLINUX_INIT} \
55 ${KBUILD_VMLINUX_MAIN}
56 fi
57}
58
59# Link of vmlinux.o used for section mismatch analysis
60# ${1} output file
61modpost_link()
62{
63 local objects
64
65 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
66 objects="--whole-archive built-in.o"
67 else
68 objects="${KBUILD_VMLINUX_INIT} \
69 --start-group \
70 ${KBUILD_VMLINUX_MAIN} \
71 --end-group"
72 fi
73 ${LD} ${LDFLAGS} -r -o ${1} ${objects}
74}
75
76# Link of vmlinux
77# ${1} - optional extra .o files
78# ${2} - output file
79vmlinux_link()
80{
81 local lds="${objtree}/${KBUILD_LDS}"
82 local objects
83
84 if [ "${SRCARCH}" != "um" ]; then
85 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
86 objects="--whole-archive built-in.o ${1}"
87 else
88 objects="${KBUILD_VMLINUX_INIT} \
89 --start-group \
90 ${KBUILD_VMLINUX_MAIN} \
91 --end-group \
92 ${1}"
93 fi
94
95 ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
96 -T ${lds} ${objects}
97 else
98 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
99 objects="-Wl,--whole-archive built-in.o ${1}"
100 else
101 objects="${KBUILD_VMLINUX_INIT} \
102 -Wl,--start-group \
103 ${KBUILD_VMLINUX_MAIN} \
104 -Wl,--end-group \
105 ${1}"
106 fi
107
108 ${CC} ${CFLAGS_vmlinux} -o ${2} \
109 -Wl,-T,${lds} \
110 ${objects} \
111 -lutil -lrt -lpthread
112 rm -f linux
113 fi
114}
115
116
117# Create ${2} .o file with all symbols from the ${1} object file
118kallsyms()
119{
120 info KSYM ${2}
121 local kallsymopt;
122
123 if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
124 kallsymopt="${kallsymopt} --symbol-prefix=_"
125 fi
126
127 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
128 kallsymopt="${kallsymopt} --all-symbols"
129 fi
130
131 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
132 kallsymopt="${kallsymopt} --absolute-percpu"
133 fi
134
135 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
136 kallsymopt="${kallsymopt} --base-relative"
137 fi
138
139 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
140 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
141
142 local afile="`basename ${2} .o`.S"
143
144 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
145 ${CC} ${aflags} -c -o ${2} ${afile}
146}
147
148# Create map file with all symbols from ${1}
149# See mksymap for additional details
150mksysmap()
151{
152 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
153}
154
155sortextable()
156{
157 ${objtree}/scripts/sortextable ${1}
158}
159
160# Delete output files in case of error
161cleanup()
162{
163 rm -f .old_version
164 rm -f .tmp_System.map
165 rm -f .tmp_kallsyms*
166 rm -f .tmp_version
167 rm -f .tmp_vmlinux*
168 rm -f built-in.o
169 rm -f System.map
170 rm -f vmlinux
171 rm -f vmlinux.o
172}
173
174on_exit()
175{
176 if [ $? -ne 0 ]; then
177 cleanup
178 fi
179}
180trap on_exit EXIT
181
182on_signals()
183{
184 exit 1
185}
186trap on_signals HUP INT QUIT TERM
187
188#
189#
190# Use "make V=1" to debug this script
191case "${KBUILD_VERBOSE}" in
192*1*)
193 set -x
194 ;;
195esac
196
197if [ "$1" = "clean" ]; then
198 cleanup
199 exit 0
200fi
201
202# We need access to CONFIG_ symbols
203case "${KCONFIG_CONFIG}" in
204*/*)
205 . "${KCONFIG_CONFIG}"
206 ;;
207*)
208 # Force using a file from the current directory
209 . "./${KCONFIG_CONFIG}"
210esac
211
212# Update version
213info GEN .version
214if [ ! -r .version ]; then
215 rm -f .version;
216 echo 1 >.version;
217else
218 mv .version .old_version;
219 expr 0$(cat .old_version) + 1 >.version;
220fi;
221
222# final build of init/
223${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init GCC_PLUGINS_CFLAGS="${GCC_PLUGINS_CFLAGS}"
224
225archive_builtin
226
227#link vmlinux.o
228info LD vmlinux.o
229modpost_link vmlinux.o
230
231# modpost vmlinux.o to check for section mismatches
232${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
233
234kallsymso=""
235kallsyms_vmlinux=""
236if [ -n "${CONFIG_KALLSYMS}" ]; then
237
238 # kallsyms support
239 # Generate section listing all symbols and add it into vmlinux
240 # It's a three step process:
241 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
242 # but __kallsyms is empty.
243 # Running kallsyms on that gives us .tmp_kallsyms1.o with
244 # the right size
245 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
246 # the right size, but due to the added section, some
247 # addresses have shifted.
248 # From here, we generate a correct .tmp_kallsyms2.o
249 # 3) That link may have expanded the kernel image enough that
250 # more linker branch stubs / trampolines had to be added, which
251 # introduces new names, which further expands kallsyms. Do another
252 # pass if that is the case. In theory it's possible this results
253 # in even more stubs, but unlikely.
254 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
255 # other bugs.
256 # 4) The correct ${kallsymso} is linked into the final vmlinux.
257 #
258 # a) Verify that the System.map from vmlinux matches the map from
259 # ${kallsymso}.
260
261 kallsymso=.tmp_kallsyms2.o
262 kallsyms_vmlinux=.tmp_vmlinux2
263
264 # step 1
265 vmlinux_link "" .tmp_vmlinux1
266 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
267
268 # step 2
269 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
270 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
271
272 # step 3
273 size1=$(stat -c "%s" .tmp_kallsyms1.o)
274 size2=$(stat -c "%s" .tmp_kallsyms2.o)
275
276 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
277 kallsymso=.tmp_kallsyms3.o
278 kallsyms_vmlinux=.tmp_vmlinux3
279
280 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
281
282 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
283 fi
284fi
285
286info LD vmlinux
287vmlinux_link "${kallsymso}" vmlinux
288
289if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
290 info SORTEX vmlinux
291 sortextable vmlinux
292fi
293
294info SYSMAP System.map
295mksysmap vmlinux System.map
296
297# step a (see comment above)
298if [ -n "${CONFIG_KALLSYMS}" ]; then
299 mksysmap ${kallsyms_vmlinux} .tmp_System.map
300
301 if ! cmp -s System.map .tmp_System.map; then
302 echo >&2 Inconsistent kallsyms data
303 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
304 exit 1
305 fi
306fi
307
308# We made a new kernel - delete old version file
309rm -f .old_version
1#!/bin/sh
2#
3# link vmlinux
4#
5# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
6# $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
7# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
8# Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
9#
10# vmlinux
11# ^
12# |
13# +-< $(KBUILD_VMLINUX_INIT)
14# | +--< init/version.o + more
15# |
16# +--< $(KBUILD_VMLINUX_MAIN)
17# | +--< drivers/built-in.o mm/built-in.o + more
18# |
19# +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31# Nice output in kbuild format
32# Will be supressed by "make -s"
33info()
34{
35 if [ "${quiet}" != "silent_" ]; then
36 printf " %-7s %s\n" ${1} ${2}
37 fi
38}
39
40# Link of vmlinux.o used for section mismatch analysis
41# ${1} output file
42modpost_link()
43{
44 ${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT} \
45 --start-group ${KBUILD_VMLINUX_MAIN} --end-group
46}
47
48# Link of vmlinux
49# ${1} - optional extra .o files
50# ${2} - output file
51vmlinux_link()
52{
53 local lds="${objtree}/${KBUILD_LDS}"
54
55 if [ "${SRCARCH}" != "um" ]; then
56 ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
57 -T ${lds} ${KBUILD_VMLINUX_INIT} \
58 --start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1}
59 else
60 ${CC} ${CFLAGS_vmlinux} -o ${2} \
61 -Wl,-T,${lds} ${KBUILD_VMLINUX_INIT} \
62 -Wl,--start-group \
63 ${KBUILD_VMLINUX_MAIN} \
64 -Wl,--end-group \
65 -lutil ${1}
66 rm -f linux
67 fi
68}
69
70
71# Create ${2} .o file with all symbols from the ${1} object file
72kallsyms()
73{
74 info KSYM ${2}
75 local kallsymopt;
76
77 if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
78 kallsymopt="${kallsymopt} --symbol-prefix=_"
79 fi
80
81 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
82 kallsymopt="${kallsymopt} --all-symbols"
83 fi
84
85 if [ -n "${CONFIG_ARM}" ] && [ -n "${CONFIG_PAGE_OFFSET}" ]; then
86 kallsymopt="${kallsymopt} --page-offset=$CONFIG_PAGE_OFFSET"
87 fi
88
89 if [ -n "${CONFIG_X86_64}" ]; then
90 kallsymopt="${kallsymopt} --absolute-percpu"
91 fi
92
93 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
94 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
95
96 ${NM} -n ${1} | \
97 scripts/kallsyms ${kallsymopt} | \
98 ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
99}
100
101# Create map file with all symbols from ${1}
102# See mksymap for additional details
103mksysmap()
104{
105 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
106}
107
108sortextable()
109{
110 ${objtree}/scripts/sortextable ${1}
111}
112
113# Delete output files in case of error
114trap cleanup SIGHUP SIGINT SIGQUIT SIGTERM ERR
115cleanup()
116{
117 rm -f .old_version
118 rm -f .tmp_System.map
119 rm -f .tmp_kallsyms*
120 rm -f .tmp_version
121 rm -f .tmp_vmlinux*
122 rm -f System.map
123 rm -f vmlinux
124 rm -f vmlinux.o
125}
126
127#
128#
129# Use "make V=1" to debug this script
130case "${KBUILD_VERBOSE}" in
131*1*)
132 set -x
133 ;;
134esac
135
136if [ "$1" = "clean" ]; then
137 cleanup
138 exit 0
139fi
140
141# We need access to CONFIG_ symbols
142case "${KCONFIG_CONFIG}" in
143*/*)
144 . "${KCONFIG_CONFIG}"
145 ;;
146*)
147 # Force using a file from the current directory
148 . "./${KCONFIG_CONFIG}"
149esac
150
151#link vmlinux.o
152info LD vmlinux.o
153modpost_link vmlinux.o
154
155# modpost vmlinux.o to check for section mismatches
156${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
157
158# Update version
159info GEN .version
160if [ ! -r .version ]; then
161 rm -f .version;
162 echo 1 >.version;
163else
164 mv .version .old_version;
165 expr 0$(cat .old_version) + 1 >.version;
166fi;
167
168# final build of init/
169${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
170
171kallsymso=""
172kallsyms_vmlinux=""
173if [ -n "${CONFIG_KALLSYMS}" ]; then
174
175 # kallsyms support
176 # Generate section listing all symbols and add it into vmlinux
177 # It's a three step process:
178 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
179 # but __kallsyms is empty.
180 # Running kallsyms on that gives us .tmp_kallsyms1.o with
181 # the right size
182 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
183 # the right size, but due to the added section, some
184 # addresses have shifted.
185 # From here, we generate a correct .tmp_kallsyms2.o
186 # 2a) We may use an extra pass as this has been necessary to
187 # woraround some alignment related bugs.
188 # KALLSYMS_EXTRA_PASS=1 is used to trigger this.
189 # 3) The correct ${kallsymso} is linked into the final vmlinux.
190 #
191 # a) Verify that the System.map from vmlinux matches the map from
192 # ${kallsymso}.
193
194 kallsymso=.tmp_kallsyms2.o
195 kallsyms_vmlinux=.tmp_vmlinux2
196
197 # step 1
198 vmlinux_link "" .tmp_vmlinux1
199 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
200
201 # step 2
202 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
203 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
204
205 # step 2a
206 if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
207 kallsymso=.tmp_kallsyms3.o
208 kallsyms_vmlinux=.tmp_vmlinux3
209
210 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
211
212 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
213 fi
214fi
215
216info LD vmlinux
217vmlinux_link "${kallsymso}" vmlinux
218
219if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
220 info SORTEX vmlinux
221 sortextable vmlinux
222fi
223
224info SYSMAP System.map
225mksysmap vmlinux System.map
226
227# step a (see comment above)
228if [ -n "${CONFIG_KALLSYMS}" ]; then
229 mksysmap ${kallsyms_vmlinux} .tmp_System.map
230
231 if ! cmp -s System.map .tmp_System.map; then
232 echo >&2 Inconsistent kallsyms data
233 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
234 cleanup
235 exit 1
236 fi
237fi
238
239# We made a new kernel - delete old version file
240rm -f .old_version